#!/usr/bin/python
# Copyright (c) 2014 Adafruit Industries
# Author: Tony DiCola
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions: 

import sys 
import Adafruit_DHT

sensor = 11  # Festlegung des Sensortyps
pin = 4  # Festlegung der Pin Nummer
# Versuche Daten vom Sensor zu lesen. Die read_retry Methode versucht bis zu
# 15 mal Daten zu empfangen (Wartet 2 Sekunden zwischen jedem Versuch).
humidity, temperature = Adafruit_DHT.read_retry(sensor, pin)
# Die untere Zeile unkommentieren um die Temperatur in Fahrenheit anzeigen zu lassen.
# temperature = temperature * 9/5.0 + 32

# Manchmal kann der Sensor nicht ausgelesen werden.
# Das Ergebnis wird dann Null sein.
# Sollten beide Ergebnisse Null sein wird in die
# Konsole "Fehler beim Lesen. Versuchen Sie es Erneut!" ausgegeben.
if humidity is not None and temperature is not None:
    print('Temp={0:0.1f}*  Humidity={1:0.1f}%'.format(temperature, humidity))
else:
    print('Fehler beim Lesen. Versuchen sie es Erneut!')
sys.exit(1)
